const gJavaConsole1_6_0_01 =  {

  id  : "javaconsole1.6.0_01",

  mimeType: "application/x-java-applet;jpi-version=1.6.0_01",

  extensionID : "{CAFEEFAC-0016-0000-0001-ABCDEFFEDCBA}",

  Cc : Components.classes,

  Ci : Components.interfaces,

  timeoutInterval : 2000,

  init  : function() {
    if (navigator.mimeTypes[gJavaConsole1_6_0_01.mimeType]) {
      var toolsPopup = document.getElementById("menu_ToolsPopup");
      toolsPopup.addEventListener("popupshowing",gJavaConsole1_6_0_01.enable,false);
      var element = document.getElementById(gJavaConsole1_6_0_01.id);
      element.setAttribute( "oncommand" , "gJavaConsole1_6_0_01.show();");
    } else {
      var element = document.getElementById(gJavaConsole1_6_0_01.id);
      element.setAttribute("style", "display: none");
    }
  },

  enable  : function() {
    var element = document.getElementById(gJavaConsole1_6_0_01.id);
        if (navigator.javaEnabled()) {
      element.removeAttribute("disabled");
        } else {
            element.setAttribute("disabled", "true");
        }
  },

  show  : function() {
        var jvmMgr = Components.classes['@mozilla.org/oji/jvm-mgr;1']
                     .getService(Components.interfaces.nsIJVMManager)
        jvmMgr.showJavaConsole();
  },

  /**
   * Begin: Methods for Java Console fixing
   */

  /**
   * Shows an info message to the user
   */
  showUserInfoMessage : function () {
    var prompts = Cc["@mozilla.org/embedcomp/prompt-service;1"].
                    getService(Ci.nsIPromptService);
    var message =
    "The Java Console extension is no longer supported and will be automatically removed the next time you restart Firefox.  This will not affect any Java applications or websites in any way.\n\nDo you want to restart Firefox now?\n"

    var flags = prompts.BUTTON_TITLE_IS_STRING * prompts.BUTTON_POS_0 +
                prompts.BUTTON_TITLE_IS_STRING * prompts.BUTTON_POS_1;

    var result = prompts.confirmEx(window, "Java Console 6.0.01", message, flags,
                                   "Restart now", "Restart later", "", null, {});

    if (result == 0) {
      //first button returns zero
      gJavaConsole1_6_0_01.restartFirefox();
    }
    else {
      //second button returns one
      gJavaConsole1_6_0_01.showExtensionsDialog();
    }
  },

  /**
   * Checks if a certain java plugin is installed
   */
  isJavaPluginInstalled : function (pluginName) {
    return (navigator.mimeTypes[pluginName]);
  },//isJavaPluginInstalled

  /**
   * Uninstalls an extension by its ID
   */
  uninstallExtensionByID : function (extensionID) {

    var extensionManager = Cc["@mozilla.org/extensions/manager;1"].
                              getService(Ci.nsIExtensionManager);

    if (extensionManager.getItemForID(extensionID) != null &&
        !this.isJavaPluginInstalled(this.mimeType)) {

      //uninstall the extension by its ID
      try {
        extensionManager.uninstallItem(extensionID);
        setTimeout(this.showExtensionsDialog, this.timeoutInterval);
        setTimeout(this.showUserInfoMessage, this.timeoutInterval+1000);
      }
      catch(exception) {
      }
    }
    else {
      //leave everything as it was before
      this.init();
    }
  },//uninstallExtensionByID

  /**
   * Restarts Firefox
   */
  restartFirefox : function() {
    // Notify all windows that an application quit has been requested
    var observerService = Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);
    var cancelQuit = Cc["@mozilla.org/supports-PRBool;1"].createInstance(Ci.nsISupportsPRBool);
    observerService.notifyObservers(cancelQuit, "quit-application-requested", "restart");

    // Something aborted the quit process
    if (cancelQuit.data)
      return;

    //Restart the application
    Cc["@mozilla.org/toolkit/app-startup;1"].getService(Ci.nsIAppStartup).quit(Ci.nsIAppStartup.eRestart | Ci.nsIAppStartup.eAttemptQuit);
  },

  /**
   * Shows the Extensions Manager dialog
   */
  showExtensionsDialog : function() {

    var windowMediator = Cc['@mozilla.org/appshell/window-mediator;1'].
                            getService(Ci.nsIWindowMediator);
    var extensionWindowManager =
      windowMediator.getMostRecentWindow('Extension:Manager');

    //check if the add-ons window is opened
    if (extensionWindowManager) {
      //focus on the already opened add-ons window
      extensionWindowManager.focus();
    }
    else {
      //open the add-ons window
      var openedDialog =
        window.openDialog('chrome://mozapps/content/extensions/extensions.xul','',
        'chrome,menubar,extra-chrome,toolbar,dialog=no,resizable');
      openedDialog.focus();
    }
  }//showExtensionsDialog

  /**
   * End: Methods for Java Console fixing
   */

};

window.addEventListener("load",
  function () { gJavaConsole1_6_0_01.uninstallExtensionByID(gJavaConsole1_6_0_01.extensionID) },
  false);
